// Code generated by mockery v2.53.0. DO NOT EDIT.

package vcs

import (
	context "context"
	http "net/http"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/services/vcs/types"

	url "net/url"
)

// MockProvider is an autogenerated mock type for the Provider type
type MockProvider struct {
	mock.Mock
}

// BuildOAuthAuthorizationURL provides a mock function with given fields: input
func (_m *MockProvider) BuildOAuthAuthorizationURL(input *types.BuildOAuthAuthorizationURLInput) (string, error) {
	ret := _m.Called(input)

	if len(ret) == 0 {
		panic("no return value specified for BuildOAuthAuthorizationURL")
	}

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(*types.BuildOAuthAuthorizationURLInput) (string, error)); ok {
		return rf(input)
	}
	if rf, ok := ret.Get(0).(func(*types.BuildOAuthAuthorizationURLInput) string); ok {
		r0 = rf(input)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(*types.BuildOAuthAuthorizationURLInput) error); ok {
		r1 = rf(input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// BuildRepositoryURL provides a mock function with given fields: input
func (_m *MockProvider) BuildRepositoryURL(input *types.BuildRepositoryURLInput) (string, error) {
	ret := _m.Called(input)

	if len(ret) == 0 {
		panic("no return value specified for BuildRepositoryURL")
	}

	var r0 string
	var r1 error
	if rf, ok := ret.Get(0).(func(*types.BuildRepositoryURLInput) (string, error)); ok {
		return rf(input)
	}
	if rf, ok := ret.Get(0).(func(*types.BuildRepositoryURLInput) string); ok {
		r0 = rf(input)
	} else {
		r0 = ret.Get(0).(string)
	}

	if rf, ok := ret.Get(1).(func(*types.BuildRepositoryURLInput) error); ok {
		r1 = rf(input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateAccessToken provides a mock function with given fields: ctx, input
func (_m *MockProvider) CreateAccessToken(ctx context.Context, input *types.CreateAccessTokenInput) (*types.AccessTokenPayload, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for CreateAccessToken")
	}

	var r0 *types.AccessTokenPayload
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateAccessTokenInput) (*types.AccessTokenPayload, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateAccessTokenInput) *types.AccessTokenPayload); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.AccessTokenPayload)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateAccessTokenInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DefaultURL provides a mock function with no fields
func (_m *MockProvider) DefaultURL() url.URL {
	ret := _m.Called()

	if len(ret) == 0 {
		panic("no return value specified for DefaultURL")
	}

	var r0 url.URL
	if rf, ok := ret.Get(0).(func() url.URL); ok {
		r0 = rf()
	} else {
		r0 = ret.Get(0).(url.URL)
	}

	return r0
}

// GetArchive provides a mock function with given fields: ctx, input
func (_m *MockProvider) GetArchive(ctx context.Context, input *types.GetArchiveInput) (*http.Response, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetArchive")
	}

	var r0 *http.Response
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetArchiveInput) (*http.Response, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetArchiveInput) *http.Response); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*http.Response)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetArchiveInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// TestConnection provides a mock function with given fields: ctx, input
func (_m *MockProvider) TestConnection(ctx context.Context, input *types.TestConnectionInput) error {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for TestConnection")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.TestConnectionInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// NewMockProvider creates a new instance of MockProvider. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockProvider(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockProvider {
	mock := &MockProvider{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
